/* $Id: vga_text16.h,v 1.5 1998/11/24 18:45:21 marcus Exp $
******************************************************************************

   IBM VGA Series/Standard -- hardware text mode manipulation macros

   Copyright (C) 1995          Steffen Seeger  [seeger@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


#ifndef _VGA_TEXT16_H_
#define _VGA_TEXT16_H_

#include <kgi/system.h>

#define TEXT16_MAGIC    0xB00B0016

/* `charcell' type definition and helping operators */
#define ATTR(x)		(((x)>>8)&0xFF)
#define BGATTR(x)	(((x)>>12)&0x0F)
#define FGATTR(x)	(((x)>>8)&0x0F)
#define CHAR(x)		((x)&0xFF)
#define CHARSET(p,c)	{*(p) = ((*(p)) & 0xFF00) | (c);}
#define ATTRSET(p,a)	{*(p) = ((*(p)) & 0x00FF) | ((a)<<8);}
#define CASET(p,c,a)	{*(p) = ((c)&0xFF) | ((a)<<8);}
typedef kgiu16 charcell;

#endif
